package {
	import flash.events.KeyboardEvent;
	import skoool.lo.events.SlideEvent;
	import skoool.lo.events.ToggleEvent;
	import skoool.lo.events.NavEvent;
	import skoool.lo.states.LO;
	import skoool.lo.utils.Debugger;
	import skoool.lo.utils.TextRender;
	
	import skoool.lo.basics.controllers.LOController;
	import skoool.lo.basics.states.LOState;
	import skoool.lo.basics.views.LOView;
	import skoool.lo.basics.views.NavView;	
	
	
	import flash.events.IOErrorEvent;
	import flash.net.navigateToURL;
	import flash.text.TextField;
	import flash.display.Loader;
	import flash.events.ProgressEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	public class Main extends MovieClip {
		
		// constant xmlFile name
		public static const strXMLFileName:String = "lo.xml";
		// constant swfFile name
		public static const strSWFFileName:String = "lo.swf";		
		// const mp3 folder
		//public static const strMP3FolderName:String = "mp3";		
		
		private var strLOID:String;
		
		private var lo:LO;
		var loState:LOState;
		var loController:LOController;
		var loView:LOView;
		var navView:NavView;
			
	
		public function Main() {
			this.visible = false;
			
			// set the output for the debugger
			Debugger.txtDebug = this.getChildByName("txtDebug") as TextField;
			
			mcLaunch.addEventListener(MouseEvent.CLICK, mouseLaunch);
			
			var loID:String = root.loaderInfo.parameters.loID;			
			if (loID != null) {
				launch(loID);
			} else {
				/*
				var request:URLRequest=new URLRequest("javascript:alert('No LO ID provided!')");
				navigateToURL(request,'_self');
				*/
				mouseLaunch(new MouseEvent("dave"));
			}
		}
		
		private function launch(in_id:String):void {
			strLOID = in_id;	
			loadXML();
		}
		
		private function mouseLaunch(e:Event):void {			
			strLOID = txtLOID.text;
			loadXML();			
		}
		
		private function loadXML():void 
		{
			txtLOID.visible = mcLaunch.visible = false;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, createLO);			
			loader.load(new URLRequest(".\\" + strLOID + "\\" + strXMLFileName));			
		}
		
		// TODO :: add progress loading
		private function onSwfLoading(e:ProgressEvent):void
		{
			var percent:Number = e.bytesLoaded / e.bytesTotal;
			Debugger.traceOut(percent + "%", Debugger.INFORMATION);
		}
		
		// xmlLoadComplete function is invoked once XML file has loaded
		// @param	event
		private function createLO(e:Event):void
		{
			lo = new LO(new XML(e.target.data));
			lo.addEventListener(LO.LOAD_COMPLETE, createLOState);
		}
		
		private function createLOState(e:Event):void {
			// once the lo is created, use the culture to init the Textrender
			TextRender.initialise(lo.culture);
			
			loState = new LOState(lo);
			createController();
			
		}
		
		private function createController():void 
		{
			loController = new LOController(loState);
			// delegate keypresses to the controller
			stage.addEventListener(KeyboardEvent.KEY_DOWN, loController.keyPress);
			
			loadSwfAsset();
		}
		
		private function loadSwfAsset():void 
		{
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, createViews);
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, onSwfLoading);			
			loader.load(new URLRequest(".\\" + strLOID + "\\" + strSWFFileName));
		}
		
		// create views - called when swf load complete
		// @param	event
		private function createViews(e:Event):void
		{			
			var mcSwf:MovieClip = e.currentTarget.content as MovieClip;
			
			navView = new NavView(this, loController);
			loView = new LOView(this, loController, mcSwf);
			
			/* slide change */
			// add a listerner to the LO state to call update in lo view
			loState.addEventListener(SlideEvent.SLIDE_CHANGED, loView.update);
			// add listener to the lostate to call update in nav view
			loState.addEventListener(NavEvent.NAV_CHANGED, navView.update);			
			/* pause */
			// add listener to the lostate to call pause in lo view
			loState.addEventListener(ToggleEvent.PAUSE, loView.pause);			
			// add listener to the lostate to call pause in nav view
			loState.addEventListener(ToggleEvent.PAUSE, navView.pause);
			
			/* mute */
			// add listener to the lostate to call pause in lo view
			loState.addEventListener(ToggleEvent.MUTE, loView.mute);
			// add listener to the lostate to call pause in nav view
			loState.addEventListener(ToggleEvent.MUTE, navView.mute);			
			
			addChild(mcSwf);
			
			start();			
		}	
		
		private function start():void 
		{
			this.visible = true;
			loController.next();
		}
		
	}

}

